%utilizziamo un filtro differenza per eliminare del rumore
%a bassa frequenza, quindi lento, dal segnale cardiaco

%l’uscita del filtro al tempo n, indicata come y[n]

%dipende dall’ingresso del filtro al tempo n meno quella al tempo n-1

%quindi y[n]=x[n]-x[n-1]

%un segnale che non cambia fornirà uscita nulla

%un segnale che cambia velocemente, fornirà uscita significativa

clear all
close all
load ecg_es_20121128.mat
%qui  presente un vettore colonna dove  contenuto il 
%segnale elettrocardigrafico


t=dt*[0:length(ecg)-1];%asse temporale con passo pari a dt
figure;plot(t,ecg)%grafico del segnale ecg

rumore=sin(2*pi*0.1*t);% si simula un rumore lento, una oscillazione lenta 
sig=ecg'+rumore;%sommiamo il segnale pulito al rumore
%l'apice serve per trasformare il vettore colonna dello ecg
%in vettore riga, per poterlo sommare al rumore
figure;plot(t,sig);hold on;plot(t, rumore,'r-') %rappresentiamo nello stesso grafico 
%i due risultati

Num=[1 -1];Den=1;%il nostro filtro
segnale_filtrato=filter(Num,Den,sig); 
figure;plot(segnale_filtrato) %si vede come non solo è stata ridotta l’oscillazione
%inserita, ma anche le variazioni più lente del segnale ecg